/*			- MEMSTRUC.I -

   Include file used by MALLOC.C, FREE.C etc.

$Name: V3_34A $	   

*/

/*
#ifndef MEM_ATTRIBUTE
#define MEM_ATTRIBUTE  huge
#endif

#ifndef PTR_ATTRIBUTE
#define PTR_ATTRIBUTE MEM_ATTRIBUTE
#endif

typedef struct
  {
    char busy;
    char PTR_ATTRIBUTE *next;
  } _m_header;
*/
/*                      - MEMSTRUC.I -

   Include file used by MALLOC.C, FREE.C etc.

   $Name: V3_34J V3_34I V3_34H V3_34G $

   Copyright 1986 - 1999 IAR Systems. All rights reserved.
*/

#ifndef MEMSTRUC_I
#define MEMSTRUC_I

#ifdef MEM_ATTRIBUTE
#undef MEM_ATTRIBUTE
#endif
#define MEM_ATTRIBUTE  huge


#ifdef PTR_ATTRIBUTE
#undef PTR_ATTRIBUTE
#endif
#define PTR_ATTRIBUTE MEM_ATTRIBUTE


/* The header for each allocated region on the heap */
typedef struct
{
  char busy;
  char PTR_ATTRIBUTE *next;
} _m_header;

/* A union that is here to get the maximum alignment bucket */
typedef union
{
  long l;
  long double ld;
  char *p;
} __align_union__;

/* Get number of align bucket from number of bytes in the heap */
#define __HEAP_SIZE__(x) ((x) / sizeof(__align_union__))

#ifndef __MAX_ALIGNMENT__
/* Note, this macro must be used in run-time code */
#if __IAR_SYSTEMS_ICC__ < 2 || !defined(__ALIGNOF__)
#define __ALIGNOF__(type) (sizeof(struct {type y; char a;}) - sizeof(type))
#endif
#define __MAX_ALIGNMENT__ (__ALIGNOF__(__align_union__))
#endif

#endif /* MEMSTRUC_I */
